﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class Hydrant : Interactable {
    public SpookyObject[] Targets;

    public bool On = true;

    public float force;

    Transform thisTransform;
    Animator animator;

    Vector2 topLeft;
    Vector2 botRight;

    void Awake()
    {
        thisTransform = transform;
        animator = GetComponent<Animator>();

        Collider2D col = GetComponent<Collider2D>();
        topLeft = col.bounds.min;
        botRight = col.bounds.max;
    }

    void Update()
    {

    }

    public override void Interact()
    {
        On = !On;
        SetOn();
    }

    void SetOn()
    {
        animator.SetBool("On", On);

        if (On)
        {
            foreach (SpookyObject scare in Targets)
            {
                scare.Activate();
            }
        }
        else
        {
            foreach (SpookyObject scare in Targets)
            {
                scare.Deactivate();
            }
        }


        if(On)
        {
            Collider2D[] colliders = Physics2D.OverlapAreaAll(topLeft, botRight);

            foreach (Collider2D col in colliders)
            {
                Person person = col.GetComponent<Person>();

                if (person != null)
                {
                    Vector2 f = (col.transform.position - transform.position).normalized * force;
                    f.y += force;
                    person.Kill(f);
                }
            }
        }
    }
}
