﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class FloatyText : MonoBehaviour {
    public float floatSpeed;
    public float maxFloatDistance;
    Vector3 floatVector;
    bool shouldFloat;

    Transform thisTransform;
    RectTransform thisRectTransform;
    Text thisText;

    Vector3 originalPos;

    public void Awake()
    {
        if(thisText == null)
        {
            thisTransform = transform;
            thisRectTransform = GetComponent<RectTransform>();
            thisText = GetComponent<Text>();
        }
    }

    public void Update()
    {
        if(shouldFloat)
        {
            float f = floatSpeed * Time.deltaTime;
            floatVector.y += f;
            thisTransform.position = Camera.main.WorldToScreenPoint(originalPos) + floatVector;
            
            if(floatVector.y > maxFloatDistance)
            {
                Destroy(gameObject);
            }
        }
    }

	public void Init(Vector3 worldPos, string text, bool shouldFloat)
	{
        thisTransform = transform;
        thisRectTransform = GetComponent<RectTransform>();
        thisText = GetComponent<Text>();

        this.shouldFloat = shouldFloat;

        thisText.text = text;

        originalPos = worldPos;
	}
}
