﻿using UnityEngine;
using System.Collections;

public class LightSwitch : Interactable {
	public SpookyObject[] Targets;

	public bool On = true;

	Animator animator;

	void Awake()
	{
		animator = GetComponent<Animator> ();
	}

	void Update () {
	
	}

	public override void Interact ()
	{
		On = !On;
		SetOn ();
	}

	void SetOn()
	{
		animator.SetBool ("On", On);
        
        if(On)
        {
            foreach (SpookyObject scare in Targets)
            {
                scare.Activate();
            }
        }
        else
        {
            foreach (SpookyObject scare in Targets)
            {
                scare.Deactivate();
            }
        }
	}
}
