﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class PlayerController : MonoBehaviour {
    public SpriteRenderer thisRenderer;
    public float Velocity;

	Vector3 velocity;

    Rigidbody2D body;
	Animator thisAnimator;
	Transform thisTransform;
    Collider2D thisCollider;

    LayerMask GhostLayer;
    LayerMask SolidLayer;

    bool solid = false;


    public Text interactText;
    public Text solidText;

	void Awake () {
		body = GetComponent<Rigidbody2D> ();
		thisAnimator = GetComponentInChildren<Animator>();
		thisTransform = GetComponent<Transform> ();

        GhostLayer = LayerMask.NameToLayer("PlayerGhost");
        SolidLayer = LayerMask.NameToLayer("PlayerSolid");

        solid = true;

        gameObject.layer = SolidLayer;
        Color c = thisRenderer.color;
        c.a = .9f;
        thisRenderer.color = c;
    }
	
	// Update is called once per frame
	void Update () {
		velocity = new Vector3 ();

		float horizontal = Input.GetAxis ("Horizontal");
		float vertical = Input.GetAxis ("Vertical");
		if (horizontal != 0.0f) {
			velocity.x = horizontal * Velocity;	
		}

		if (vertical != 0.0f) {
			velocity.y = vertical * Velocity;
		}

		if (thisAnimator != null) {
			thisAnimator.SetFloat("Direction",velocity.x);
		}

		
		Collider2D[] colliders = Physics2D.OverlapCircleAll(thisTransform.position, 5.0f);
        interactText.text = "";
		foreach(Collider2D c in colliders)
		{
			Interactable i = c.GetComponent<Interactable>();
			if(i != null)
			{
                interactText.text = "E - Use " + c.gameObject.name;
                if (Input.GetButtonUp("Interact"))
                {
					i.Interact();
                }
                break;
			}
		}

        if(Input.GetKeyUp(KeyCode.R))
        {
            Application.LoadLevel("Scene");
        }

        if (Input.GetKeyUp(KeyCode.Escape))
        {
            Application.Quit();
        }

        bool wasSolid = solid;
        if (Input.GetButtonUp("Solidify"))
        {
            solid = !solid;
            
        }
        if(solid != wasSolid)
        {
            if(solid)
            {
                gameObject.layer = SolidLayer;
                Color c = thisRenderer.color;
                c.a = .9f;
                thisRenderer.color = c;
                solidText.text = "Q - Ghost";
            }
            else
            {
                gameObject.layer = GhostLayer;
                Color c = thisRenderer.color;
                c.a = .4f;
                thisRenderer.color = c;
                solidText.text = "Q - Solid";
            }
        }
	}

	void FixedUpdate()
	{
		body.velocity = velocity;
	}
}
