﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class Skateboard : MonoBehaviour {
    int LayerStill;
    int LayerMoving;

    Rigidbody2D thisBody;
    Transform thisTransform;

    bool Moving = false;

    bool Attached = false;

    Vector3 vel;

    Person attachedPerson;

    void Start()
	{
        LayerStill = LayerMask.NameToLayer("Objects");
        LayerMoving = LayerMask.NameToLayer("PersonObjects");

        thisBody = GetComponent<Rigidbody2D>();
        thisTransform = transform;
    }

    void Update()
    {
        bool wasMoving = Moving;
        if(thisBody.velocity.x > 0.25f)
        {
            Moving = true;
        }
        else
        {
            Moving = false;
        }

        if(Moving != wasMoving)
        {
            if(Moving)
            {
                gameObject.layer = LayerMoving;
            }
            else
            {
                gameObject.layer = LayerStill;
            }
        }

    }
	
    void FixedUpdate()
    {
        if(Attached)
        {
            Vector3 v = thisBody.velocity;
            v.x = vel.x;
            thisBody.velocity = v;
        }
    }

	void OnCollisionEnter2D(Collision2D collision)
    {
        PlayerController pc = collision.gameObject.GetComponent<PlayerController>();
        if (pc != null)
        {
            Vector3 v = (thisBody.position - collision.contacts[0].point) * 5f;
            v.y = thisBody.velocity.y;
            thisBody.velocity = v;
            vel = thisBody.velocity;
        }
        else
        {
            Person p = collision.gameObject.GetComponent<Person>();
            if (p != null && attachedPerson == null)
            {
                attachedPerson = p;
                p.AttachToTransform(thisTransform);
                Attached = true;
            }
            else
            {
                Breakable b = collision.gameObject.GetComponent<Breakable>();
                if (b != null)
                {
                    attachedPerson.Detach(vel);
                    Attached = false;
                    StartCoroutine(FixVelocity());
                }
            }
        }
    }

    IEnumerator FixVelocity()
    {
        //yield return new WaitForSeconds(0.01f);
        yield return new WaitForEndOfFrame();

        Vector3 v = thisBody.velocity;
        v.x = vel.x;
        thisBody.velocity = vel;
    }
}
