﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class SpookyLight : SpookyObject {
    Animator anim;
    Collider2D col;

    bool on;

    Vector2 topLeft;
    Vector2 botRight;

	void Awake()
	{
        anim = GetComponent<Animator>();
        col = GetComponent<Collider2D>();

        topLeft = col.bounds.min;
        botRight = col.bounds.max;
    }

    public override void Activate()
    {
        anim.SetBool("On", true);
        on = true;
        DoScare();
    }

    public override void Deactivate()
    {
        anim.SetBool("On", false);
        on = false;
    }

    void DoScare()
    {
        Collider2D[] colliders = Physics2D.OverlapAreaAll(topLeft, botRight);

        foreach(Collider2D col in colliders)
        {
            Person p = col.GetComponent<Person>();

            if(p != null)
            {
                p.Scare(Spookiness);
            }
        }
    }
}
